import xmlrpc.client
from contextlib import suppress
from xmlrpc.client import Fault as SupervisorFault

from tfw.config import tfwenv


class SupervisorMixin:
    supervisor = xmlrpc.client.ServerProxy(tfwenv.SUPERVISOR_HTTP_URI).supervisor

    def stop_process(self, process_name):
        with suppress(SupervisorFault):
            self.supervisor.stopProcess(process_name)

    def start_process(self, process_name):
        self.supervisor.startProcess(process_name)

    def restart_process(self, process_name):
        self.stop_process(process_name)
        self.start_process(process_name)
