from tfw.components.source_code_event_handler import SourceCodeEventHandler
from tfw.components.terminado_event_handler import TerminadoEventHandler
from tfw.components.process_managing_event_handler import ProcessManagingEventHandler
from tornado.ioloop import IOLoop

from tfw.config import tfwenv


if __name__ == '__main__':
    ide = SourceCodeEventHandler('webide', tfwenv.WEBIDE_WD)
    terminado = TerminadoEventHandler('terminado', 'terminado')
    processmanager = ProcessManagingEventHandler('processmanager', ide.monitor)

    eventhandlers = {ide, terminado, processmanager}
    try:
        IOLoop.instance().start()
    finally:
        for eh in eventhandlers: eh.cleanup()
